﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;

namespace example
{
    public partial class Form1 : Form
    {
        [DllImport("pdfmerger.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MMergeBegin();

        [DllImport("pdfmerger.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MMergeSetFiles(int id,string infile,string password,string range);

        [DllImport("pdfmerger.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MMerge(int id,string outfile);

        [DllImport("pdfmerger.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MMergeEnd(int id);

        [DllImport("pdfmerger.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MWatermark(int id, string text, int fsize, int fcolor, int position, int angle, int xoff, int yoff, int asbackground);

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string appPath = Path.GetDirectoryName(Application.ExecutablePath);
            string inFile = appPath + "\\test.pdf";
            string outFile = appPath + "\\Merged.pdf";	            
            
            int id = MMergeBegin();
            if (id <= 0)
            {
                MessageBox.Show("Creat PDF file failed!");
                return;
            }

            MMergeSetFiles(id, inFile, "", "1-3");
            MMergeSetFiles(id, inFile, "", "5");
            MMergeSetFiles(id, inFile, "", "7-9");

            int fsize = 16;
            int fcolor = 255;//red
            int position = 2;//Top-Center
            int angle = 0;
            int xoff = 0;
            int yoff = 0;
            int asbackground = 0;
            //Stamping
            MWatermark(id, "Merge into one pdf file", fsize, fcolor, position, angle, xoff, yoff, asbackground);

            MMerge(id, outFile);

            MMergeEnd(id);
            MessageBox.Show("Merge finished!");
        }
    }
}
