//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TForm1::GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadMergerDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"pdfmerger.dll");	

	m_hinstLib = LoadLibrary(path);	
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMMergeBegin = (MMergeBegin *)GetProcAddress(m_hinstLib, "MMergeBegin");
	if( pMMergeBegin == NULL ){ 
		FreeMergerDll(); 
		return FALSE;
	}
	pMMergeSetFiles = (MMergeSetFiles *)GetProcAddress(m_hinstLib, "MMergeSetFiles");
	if( pMMergeSetFiles == NULL ){ 
		FreeMergerDll(); 
		return FALSE;
	}
	pMMerge = (MMerge *)GetProcAddress(m_hinstLib, "MMerge");
	if( pMMerge == NULL ){ 
		FreeMergerDll(); 
		return FALSE;
	}
	pMMergeEnd = (MMergeEnd *)GetProcAddress(m_hinstLib, "MMergeEnd");
	if( pMMergeEnd == NULL ){ 
		FreeMergerDll(); 
		return FALSE;
	}
	pMWatermark = (MWatermark *)GetProcAddress(m_hinstLib, "MWatermark");
	if( pMWatermark == NULL ){ 
		FreeMergerDll(); 
		return FALSE;
	}
    
	return TRUE;
}
//---------------------------------------------------------------------------
BOOL TForm1::FreeMergerDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}
	return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadMergerDll() == FALSE ){
		ShowMessage("Load pdfmerge.dll failed!");
		return;
	}
	
	long id = pMMergeBegin();
	if(id<=0){
		ShowMessage("Creat PDF file failed!");
		FreeMergerDll();
		return;
	}
	char infile[256];
	GetModulePath(infile,"test.pdf");

	pMMergeSetFiles(id,infile,NULL,"1-3");
	pMMergeSetFiles(id,infile,NULL,"5");
	pMMergeSetFiles(id,infile,NULL,"7-9");

	long fsize=16;
	long fcolor=255;//red
	long position=2;//Top-Center
	long angle=0;
	long xoff=0;
	long yoff=0;
    long asbackground=0;
	//Stamping
	pMWatermark(id,"Merge into one pdf file",fsize,fcolor,position,angle,xoff,yoff,asbackground);

	char outFile[256];
	GetModulePath(outFile,"Merged.pdf");
	pMMerge(id,outFile);
	
	pMMergeEnd(id);

	FreeMergerDll();
	ShowMessage("Merge finished!");
}
//---------------------------------------------------------------------------



 